/** Pilha.java
 
 Este software  livre e pode ser redistribudo e/ou modificado
 sob os termos da GNU General Public License, como publicado pela
 Free Software Foundation.

 @author Hemerson Pistori (pistori@ec.ucdb.br)

 Este programa possui propsitos educacionais, e implementa uma 
 Pilha atravs de Lista Ligada.Ver os fontes da classe 
 {@link UsaPilha) para informaes de como utilizar a classe
 Pilha.

*/

class Pilha {

   /** Determina a estrutura de cada n da Lista Ligada usada para
       implementar a Pilha */
   class SNo {
      Object chave;
      SNo prox;
   }

   /** Ponteiro para o topo da Pilha */
   SNo Topo;

   /** Inicia a Pilha fazendo o topo apontar para null */
   Pilha() {
      Topo = null;
   }
   
   /** Insere chave na pilha */
   void Insere( Object chave ) {

      SNo No;
   
      No = new SNo();
 
   
      if(No==null)
      {
   	  System.out.println("Overflow");
      }
      else
      {
         No.chave = chave;
         No.prox = Topo;
      
         Topo = No;
      }
   }

   /** Remove um objeto do topo e o retorna. Retorna null em caso de underflow */ 
   Object Remove() {

      Object chave;
      SNo temp;
   
      if(Topo==null)
      {
   	  System.out.println("Underflow");
	  return(null);
      }
      else
      {
         chave = Topo.chave;
         temp = Topo.prox;
         Topo = temp;
      
         return(chave);
      }  	
   }

   /** Devolve o contedo completo da pilha, comeando pelo topo, no 
       formato de uma cadeia de caracteres com elementos separados 
	   por um espao */   
   String mostra() {
   
      StringBuffer saida = new StringBuffer();
      SNo no = Topo;      
	  
	  while(no != null) {
         saida.append(no.chave.toString()+" ");         	    
	     no = no.prox;
	   }
	   
	   return saida.toString();
	  
   }

   public static void main(String args[]) {

       Integer x;
       String y;
       
       Pilha p1 = new Pilha();
       Pilha p2 = new Pilha();

       p1.Insere(new Integer(4));
       p1.Insere(new Integer(8));
       p2.Insere(new String("Quinze"));

       x = (Integer) p1.Remove();
       System.out.println( x );
       x = (Integer) p1.Remove();
       System.out.println( x );
       y = (String) p2.Remove();
       System.out.println( y );

   }

}
