/** UsaPilha.java

 Este software  livre e pode ser redistribudo e/ou modificado
 sob os termos da GNU General Public License, como publicado pela
 Free Software Foundation.

 @author Hemerson Pistori (pistori@ec.ucdb.br)

 Este programa possui propsitos educacionais, e implementa uma 
 interface bastante simples para manipulao de uma Pilha,
 implementada atravs da classe {@link Pilha).

*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class UsaPilha extends JFrame  {

    Pilha pilha;
	JLabel textoEntrada;
	JTextField entrada;
    JButton botaoEmpilha;
	JButton botaoDesempilha;
	JTextArea resultado;

    /** Inicia a classe UsaPilha criando uma pilha vazia e apresentando os
	    componentes da Interface Grfica */
    public UsaPilha() {
	   pilha = new Pilha(); // Cria uma pilha.
	   criaComponentes();
	   show(); 
	};


    /** Mostra o contedo da pilha na caixa de texto "resultado" */
    private void mostraPilha() {
	   resultado.setText(pilha.mostra());
	}
	
	
    /** Cria, posiciona e inicia os componentes da Interface
	    grfica, como caixas de textos e botes */
    private void criaComponentes() {

        /** Altera o texto na barra de ttulo da Janela. */
        setTitle("Programa Simples que Utiliza uma Pilha");

        /** Cria o texto que ser mostrado acima da caixa de entrada */
        textoEntrada = new JLabel("Entrada:");
		
		/** Cria a caixa de entrada para digitao dos elementos 
		    a serem inserido.
		    O tamanho da caixa de texto  de 10 caracteres. */
		entrada = new JTextField(10);

        /** Cria o boto que ao ser clicado, empilha o elemento contido
		 na caixa de texto entrada. */
        botaoEmpilha = new JButton();
        botaoEmpilha.setText("Empilha");
        botaoEmpilha.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
			
			    // Aqui deve ser colocado o cdigo a ser executado quando
				// o usurio clicar no boto. 			
                pilha.Insere(entrada.getText());
				mostraPilha();
            }
        });

        /** Cria o boto que ao ser clicado, desempilha um elemento. */
        botaoDesempilha = new JButton();
        botaoDesempilha.setText("Desempilha");
        botaoDesempilha.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
			
			    // Aqui deve ser colocado o cdigo a ser executado quando
				// o usurio clicar no boto. 			
                pilha.Remove();
				mostraPilha();
            }
        });

        /** Cria caixa de texto para mostrar o contedo da pilha (com 20 linhas e
		   50 colunas */
        resultado = new JTextArea(20,50);
		resultado.setLineWrap(true);


        /** Determina como os elementos grficos devem ser posicionados
		 na Janela.	 */ 
		 
		Container principal = getContentPane();
		principal.setLayout(new BoxLayout(principal,BoxLayout.Y_AXIS));
		principal.add(textoEntrada);
		principal.add(entrada);
		
		/** O Cdigo abaixo  responsvel pelo alinhamento horizontal (X_AXIS) 
		    dos dois botes. Sem esse cdigos, os botes seriam alinhados
			horizontalmente (Y_AXIS) */			
		JPanel botoes = new JPanel();
		botoes.setLayout(new BoxLayout(botoes,BoxLayout.X_AXIS));
		botoes.add(botaoEmpilha);
		botoes.add(botaoDesempilha);
		
		principal.add(botoes);		
		principal.add(resultado);
		
		/** Posicionamento da Janela na Tela do Computador. */
        setLocation(100,40);

        pack();

        /** Fecha o programa quando a janela  fechada. (Sem o cdigo abaixo,
		    a janela fecha mas o programa continua aberto - porm,s inacessvel) */	         addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                System.exit(0);
            }
        });
	}
		
    public static void main(String args[]) {
	    new UsaPilha();
	}


}
